## mpich 4.2.0

=== debian/changelog ===
mpich (4.2.0-5build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:09:52 +0000

mpich (4.2.0-5build2) noble; urgency=high

  * No change rebuild against libslurm40t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:42:01 +0100

mpich (4.2.0-5build1) noble; urgency=medium

  * No-change rebuild against libpmix2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 22:51:13 +0000

mpich (4.2.0-5) unstable; urgency=medium

  * Install mod files in include dir until all deps updated

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Feb 2024 08:59:43 +0000

mpich (4.2.0-4) unstable; urgency=medium

  * Fix for ppc64 detection: Closes: #1032008
  * Put default install of *mod files in d/not-installed.Closes: #1064841

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 26 Feb 2024 14:43:24 +0000

mpich (4.2.0-3) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 26 Feb 2024 13:02:02 +0000

mpich (4.2.0-2) experimental; urgency=medium

  * Fix install locations

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 18 Feb 2024 13:34:24 +0000

mpich (4.2.0-1) experimental; urgency=medium

  * New upstream release
  * Build-conflicts libamdhip64-dev until hipcc detection code is fixed
  * Expand list of supported valgrind archs
  * Drop obsolete libmpl* install file
  * Install path fixes
  * Add fortran:Depends to libmpich-dev
  * Drop duperflous patterns in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 12 Feb 2024 12:43:13 +0000

mpich (4.1.2-3) experimental; urgency=medium

  * Change main install point to LIBDIR/mpich/{include,lib} to match
    openmpi, etc
  * Add perl depends to mpich pkg for parkill
  * Close obsolete bugs: Closes: #512142
  * Update hurd configuration. Closes: #1055455
  * Delete obsolete d/control package handling, libopa/libmpl files
  * Simplify postinst/prerm removing obsolete code
  * Drop autotools.patch, no-real128.patch - not used
  * Update autogen bash patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Nov 2023 09:37:09 +0000

=== debian/control ===
Source: mpich
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Torquil Macdonald Sørensen <torquil@gmail.com>,
           "Adam C. Powell, IV" <hazelsct@debian.org>,
           Alastair McKinstry <mckinstry@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
	       dh-sequence-fortran-mod,
               gfortran | fortran-compiler,
	       chrpath,
               hwloc-nox,
               libhwloc-dev,
	       librdmacm-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
	       libslurm-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
               libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
	       libfabric-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any !powerpc !sh4 !x32],
               libnuma-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
	       libucx-dev [amd64  ppc64el arm64],
               libpmix-dev,
               libxt-dev,
               procps,
	       python3,
               quilt,
               txt2man,
               valgrind [i386 arm64 ppc64el ppc64  amd64 powerpc armhf],
               x11proto-core-dev
Build-Conflicts: libamdhip64-dev
Build-Depends-Indep: texlive-latex-extra,
                     texlive-latex-recommended,
                     doxygen-latex
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/mpich
Vcs-Git: https://salsa.debian.org/science-team/mpich.git -b debian/latest
Homepage: https://www.mpich.org/

Package: libmpich-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: gfortran | fortran-compiler,
         g++,
         libmpich12 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${fortran:Depends},
	 mpich (= ${binary:Version})
Description: Development files for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-3.1 standard from the Argonne National Laboratory.  
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 3.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH headers and static libraries, as well
 as the compiler wrappers needed to build MPICH programs.

Package: libmpich12
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Shared libraries for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-3.1 standard from the Argonne National Laboratory.  
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 3.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH shared libraries.

Package: mpich
Architecture: any
Multi-Arch: foreign
Depends: hwloc-nox | hwloc,
         libmpich12 (= ${binary:Version}),
         ${misc:Depends},
  	 ${perl:Depends},
         ${shlibs:Depends}
Recommends: libmpich-dev (= ${binary:Version})
Suggests: mpich-doc (= ${source:Version})
Description: Implementation of the MPI Message Passing Interface standard
 MPICH is a high-performance and widely portable implementation of the
 MPI-3.1 standard from the Argonne National Laboratory.  
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 3.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the program binaries necessary to run MPICH programs.

Package: mpich-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Conflicts: lam-mpidoc,
           lam4-dev,
           mpi-doc,
           openmpi-doc,
           openmpi-mpidoc
Description: Documentation for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-3.1 standard from the Argonne National Laboratory.  
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 3.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH documentation.

=== debian/rules ===
#! /usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Drop flags on old gfortran < 10
GF_FLAGS:= $(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-9),, -fallow-invalid-boz -fallow-argument-mismatch)

export MPICHLIB_CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export MPICHLIB_CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export MPICHLIB_CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export MPICHLIB_FFLAGS=$(shell dpkg-buildflags --get FFLAGS) $(GF_FLAGS)
export MPICHLIB_FCFLAGS=$(shell dpkg-buildflags --get FFLAGS) -cpp $(GF_FLAGS)
export FFLAGS=$(shell dpkg-buildflags --get FFLAGS |  sed -e 's/-g //') $(GF_FLAGS)
export F77=f77
export TZ=UTC+0

FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
export FC


# Keep old library naming scheme
export MPILIBNAME=mpich

NO_ROMIO_ARCH:= hurd-amd64 hurd-i386
NO_VERBS_ARCH:= hurd-amd64 hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390x
NO_SLURM_ARCH:= hurd-amd64 hurd-i386 kfreebsd-amd64 kfreebsd-i386 
NO_FABRIC_ARCH:= hurd-amd64 hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390x powerpc sh4 x32
BUILTIN_ATOMICS_ARCH:= armhf riscv64 hppa
NO_REAL128_ARCH:= armel armhf mipsel hppa m68k sh5
# Pick one as default
NO_CH4_ARCH:= armel armhf i386 mipsel  hppa m68k sh4 powerpc x32 mips64el s390x
UCX_ARCH:= amd64  ppc64el arm64 

ifneq (,$(filter $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
	VERBS := --with-ibverbs
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(BUILTIN_ATOMICS_ARCH)))
	DISABLE_BUILTIN_ATOMICS:= --with-atomic-primitives=no
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(NO_FABRIC_ARCH)))
	FABRIC := --with-libfabric=/usr
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(NO_REAL128_ARCH)))
        MPICHLIB_FCFLAGS:=$(MPICHLIB_FCFLAGS) -DNO_REAL128
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(NO_SLURM_ARCH)))
	SLURM := --with-slurm=/usr 
endif

DEVICE:= --with-device=ch3
UCX:=
PMIX:=
ifeq (,$(findstring  $(DEB_HOST_ARCH),$(NO_CH4_ARCH)))
        DEVICE:= --with-device=ch4:ofi 
	PMIX:=  --with-pmix=/usr/lib/$(DEB_HOST_MULTIARCH)/pmix2
endif
ifneq (,$(filter  $(DEB_HOST_ARCH),$(UCX_ARCH)))
        DEVICE:= --with-device=ch4:ucx
	UCX:= --with-ucx=/usr
	PMIX:=  --with-pmix=/usr/lib/$(DEB_HOST_MULTIARCH)/pmix2
endif

extra_flags += \
	$(VERBS) \
	$(FABRIC) \
	$(SLURM) \
	$(PMIX) \
	$(UCX) \
	$(DEVICE) \
	$(DISABLE_BUILTIN_ATOMICS) \
	--with-pm=hydra \
	--with-hwloc-prefix=/usr \
	--with-wrapper-dl-type=none \
	--enable-shared \
	--without-yaksa \
	--prefix=/usr \
	--enable-fortran=all \
	--disable-rpath \
	--disable-wrapper-rpath \
	--sysconfdir=/etc/mpich \
        --libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/mpich/lib      \
        --includedir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/mpich/include\
	--docdir=/usr/share/doc/mpich 


# On sparc and sh4, OPA isn't available, so we need to fallback to
# emulation mode. There's a performance penalty, unfortunately.
ifneq (,$(filter $(DEB_HOST_GNU_CPU),sparc sh4))
	extra_flags += --with-atomic-primitives=no
endif

AUTOGENERATED	:= $(patsubst %.in,%,$(wildcard debian/*.in))

%: %.in
	sed 's%@DEB_HOST_MULTIARCH@%$(DEB_HOST_MULTIARCH)%g' < $< > $@

%:
	dh $@  --with fortran_mod

override_dh_autoreconf:
	./autogen.sh
	#autoreconf -f -i src/mpl src/openpa src/mpi/romio src/pm/hydra \
	#	src/mpid/ch4/netmod/ucx/ucx src/mpid/ch4/netmod/ofi/libfabric

override_dh_auto_configure: $(AUTOGENERATED)
	dh_auto_configure -- $(extra_flags) CPPFLAGS="" CFLAGS="" CXXFLAGS="" FFLAGS="$(FFLAGS)" FCFLAGS="$(FFLAGS)" BASH_SHELL=/bin/bash
	( cd src/pm/hydra && ./configure --with-hwloc-prefix=/usr $(DEVICE) FFLAGS="$(FFLAGS)"  --prefix=/usr )

override_dh_auto_build-indep:
	dh_auto_build -i
	$(MAKE) -f doc/Makefile.mk

override_dh_auto_install-arch:
	dh_auto_install -a
	$(MAKE) -C src/pm/hydra install DESTDIR=$(CURDIR)/debian/tmp

	# Rename executables (ignore upstream symlinks)
	for i in mpicc mpicxx mpifort; do \
	  (cd debian/tmp/usr/bin/ && mv $$i $$i.mpich); \
	done
    # Rename manpages
    # TODO: manpages not shipped in beta ?
	#for i in mpicc mpicxx mpiexec mpif77 mpifort; do \
	#  (cd debian/tmp/usr/share/man/man1/ && mv $$i.1 $$i.mpich.1);\
	#done

	# Fix incorrect paths in /usr/bin/mpi{cc,cxx,fort}.mpich
	for fn in debian/tmp/usr/bin/mpicc.mpich debian/tmp/usr/bin/mpicxx.mpich \
		debian/tmp/usr/bin/mpifort.mpich; do \
		sed -i 's:$(CURDIR)/debian/tmp/::g' $$fn ;\
	done

execute_after_dh_auto_clean:
	$(RM) $(AUTOGENERATED)

override_dh_fixperms-arch:
	# Hack. placed here to be run after dh_auto_install _after_ override
	chrpath -d debian/mpich/usr/bin/mpivars debian/mpich/usr/bin/mpichversion
	chrpath -d debian/libmpich12/usr/lib/*/lib*.so.*
	-rm debian/*/usr/share/doc/mpich/examples/cpi.o
	dh_fixperms -a

override_dh_installchangelogs:
	dh_installchangelogs README

# Some tests are failing on hurd-i386.
# Disable them, to be investiated later
# disable_test_archs = hurd-i386 hurd-amd64
disable_test_archs = 
# ifneq (,$(filter $(DEB_HOST_ARCH),$(disable_test_archs)))
override_dh_auto_test:
	@echo "Don't fail on tests in experimental"
	- dh_auto_test || true
# endif

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4
opts="uversionmangle=s/(\d+)((a|b|rc)\d+)/$1~$2/" http://www.mpich.org/downloads .*/mpich-([\d\.]+)\.tar\.gz

## mpich 4.2.1

=== debian/changelog ===
mpich (4.2.1-2ubuntu2) plucky; urgency=medium

  * No-change rebuild for slurm-wlm.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 17 Dec 2024 12:40:28 +0000

mpich (4.2.1-2ubuntu1) plucky; urgency=medium

  * Upload mpich 4.2.1-2 that was uploaded to unstable,
    instead of 4.2.1-2 that was previously uploaded to experimental

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 06 Dec 2024 16:28:14 +0000

mpich (4.2.1-2) unstable; urgency=medium

  * Add more autopkgtests for pkg-config, mpif77
  * Add links for mpi-c.pc mpi-fort.pc. Closes: #1088919

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Dec 2024 06:36:38 +0000

mpich (4.2.1-1) experimental; urgency=medium

  * New upstream release
  * pmix now only supports 64-bit archs; build with pmix on 64-bit only
  * Standards-Version: 4.7.0; no changes required
  * Update links; minor version now 12.4.1
  * libmpl.so, libopa.so now point to libmpich.so
  * Drop patch merged upstream

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 01 May 2024 14:07:14 +0100

mpich (4.2.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rules: Re-disable pmix: Closes: #1066735

 -- Samuel Thibault <sthibault@debian.org>  Tue, 26 Mar 2024 22:40:26 +0100

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,10 @@
 	       libfabric-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any !powerpc !sh4 !x32],
                libnuma-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
 	       libucx-dev [amd64  ppc64el arm64],
-               libpmix-dev,
+               libpmix-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 alpha ia64 ppc64 sparc64],
                libxt-dev,
                procps,
-	       python3,
-               quilt,
+               python3,
                txt2man,
                valgrind [i386 arm64 ppc64el ppc64  amd64 powerpc armhf],
                x11proto-core-dev
@@ -30,7 +29,7 @@
 Build-Depends-Indep: texlive-latex-extra,
                      texlive-latex-recommended,
                      doxygen-latex
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/science-team/mpich
 Vcs-Git: https://salsa.debian.org/science-team/mpich.git -b debian/latest
 Homepage: https://www.mpich.org/
@@ -44,6 +43,8 @@
          libmpich12 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
+         libhwloc-dev,
+         libucx-dev [amd64 ppc64el arm64],
          ${fortran:Depends},
 	 mpich (= ${binary:Version})
 Description: Development files for MPICH

=== debian/tests/control ===
Tests: version
Depends: mpich

Tests: compile-run-mpicc
Depends: gcc, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-mpif77
Depends: gfortran, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-mpif90
Depends: gfortran, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-cc-pkgconf-mpi
Depends: gcc, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-cc-pkgconf-mpi-c
Depends: gcc, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-f90-pkgconf-mpi
Depends: gfortran, mpich, libmpich-dev
#Conflicts: libopenmpi-dev

Tests: compile-run-f90-pkgconf-mpi-fort
#Conflicts: libopenmpi-dev
Depends: gfortran, mpich, libmpich-dev

## mpich 4.3.0+really4.2.1

=== debian/changelog ===
mpich (4.3.0+really4.2.1-1build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:26:55 +0200

mpich (4.3.0+really4.2.1-1) unstable; urgency=medium

  * Uploading really4.2.1 for trixie transition (to unblock unstable)
  * Use := for performance in d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 Apr 2025 13:46:38 +0100

mpich (4.2.1-5) unstable; urgency=medium

  [ Alastair McKinstry ]
  * Drop ia64 support

  [ Andreas Beckmann ]
  * Do not provide mpi-cxx.pc alternative to match openmpi.
  * Synchronize autopkgtests from src:mpi-defaults.
  * Do not ship duplicate documentation.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 26 Dec 2024 13:51:00 +0100

mpich (4.2.1-4) unstable; urgency=medium

  * Add more autopkgtests for pkg-config, mpif77
  * Add links for mpi-c.pc mpi-fort.pc. Closes: #1088919
  * Tests need to depend on pkg-config. Closes: #1089694

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Dec 2024 18:56:39 +0000

mpich (4.2.1-3) experimental; urgency=medium

  * Merge changes from 4.2.0-14.
  * Do not allow alternatives to B-D: gfortran. The build system does not
    check for flang.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Sep 2024 21:18:40 +0200

mpich (4.2.1-2) experimental; urgency=medium

  * Team upload.
  * Merge changes from 4.2.0-6.
  * Enable all hardening flags.
  * Use the symbols file for all architectures.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 30 May 2024 13:15:50 +0200

mpich (4.2.0-14) unstable; urgency=medium

  * Team upload.
  * d/rules: Parse list of UCX architectures from Build-Depends.
  * libmpich-dev: Generate the libucx-dev dependency.
  * Drop unused Build-Depends: libpmix-dev.
  * Refresh ./COPYRIGHT embedded in d/copyright.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Sep 2024 00:06:07 +0200

mpich (4.2.0-13) unstable; urgency=medium

  * Team upload.
  * Bump required libslurm-dev version.
  * Add upstream metadata.
  * Switch s390x back to ch3 to avoid eztrace autopkgtest failures.
  * Mark symbols disappearing with LTO as optional.
    (Closes: #1079142, #1081116)
  * Provide mpic++.mpich symlink.  (Closes: #1077247)
  * Drop rpath workarounds, no longer needed.
  * Simplify d/rules.
  * Drop missing-conf.patch, no longer needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 Sep 2024 21:46:09 +0200

mpich (4.2.0-12) unstable; urgency=medium

  * Team upload.
  * Re-enable ucx on ppc64el.
  * Switch s390x to ch4:ofi.
  * Drop --with-atomic-primitives=no logic, option gone since 3.4.
  * Switch B-D to valgrind-if-available to avoid hardcoding the arch list.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 25 Aug 2024 00:32:48 +0200

mpich (4.2.0-11) unstable; urgency=medium

  * Team upload.
  * d/control, d/rules: Sync architecture constraints.
  * Simplify the device selection logic.
  * Switch mips64el to ch4:ofi.
  * Simplify the --with-atomic-primitives=no logic.
  * Enable all hardening flags.
  * Use the symbols file for all architectures.
  * Update symbols file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 23 Aug 2024 04:39:59 +0200

mpich (4.2.0-10) unstable; urgency=medium

  * Fix FTBFS on amd64 due to symbols. Patch thanks to Gianfranco Costamagna
    Closes: #1075292
  * Drop unnset Depends from d/control
  * Standards-Version: 4.7.0

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Aug 2024 07:50:53 +0100

mpich (4.2.0-9) unstable; urgency=medium

  * Update d/rules to exclude ppc64el for now; add loong64 support

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 Jul 2024 08:43:53 +0100

mpich (4.2.0-8) unstable; urgency=medium

  * libucx-dev deps needs to be conditional. Drop ppc64el for now, add riscv64
    Closes: #1075965

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Jul 2024 15:16:50 +0100

mpich (4.2.0-7) unstable; urgency=medium

  * Add patch that was accidentally dropped:
     Add Deps to libmpich-dev needed for pkg-config. Closes: #1028172

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Jul 2024 11:43:54 +0100

mpich (4.2.0-6) unstable; urgency=medium

  * Team upload.
  * Run autogen.sh via dh_autoreconf.
  * Fix building twice in a row.  (Closes: #1047086)
  * Fix inverted logic when enabling features.
  * Fix non-verbose build.
  * Declare Rules-Requires-Root: no.
  * Fix symbols file for amd64.
  * libmpich-dev: Only ship .so links for libraries built from this source.
  * libmpich-dev.preinst: Perform cleanup on upgrades from versions missing
    dir_to_symlink/symlink_to_dir for the include directory.
  * libmpich-dev: Perform dir/symlink direction change for the include
    directory.  (Closes: #1071115)
  * Reproducibility: Strip -ffile-prefix-map from macros and shipped files.
  * mpich-doc: Drop unusable build system artefacts from examples.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 27 May 2024 00:33:02 +0200

mpich (4.1.2-2+hurd.1) unreleased; urgency=medium

  * Fix configure flags.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 05 Nov 2023 21:05:47 +0000

mpich (4.1.1a1+really.4.1~rc3-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 22 Jan 2023 15:47:27 +0000

mpich (4.0~b1-2) experimental; urgency=medium

  * Enable ch4
  * Enable UCX, adding dep on libucx-dev on archs
  * Enable pmix, including build-dep on libpmix-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 01 Dec 2021 12:48:05 +0000

=== debian/control ===
Source: mpich
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Torquil Macdonald Sørensen <torquil@gmail.com>,
           "Adam C. Powell, IV" <hazelsct@debian.org>,
           Alastair McKinstry <mckinstry@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
	       gfortran,
	       dh-sequence-fortran-mod,
               hwloc-nox,
               libhwloc-dev,
	       librdmacm-dev [!hurd-any],
	       libslurm-dev (>= 23.11) [!hurd-any],
	       libibverbs-dev (>= 1.1.7) [!hurd-any],
	       libfabric-dev [!hurd-any !powerpc !sh4],
	       libnuma-dev [!hurd-any],
	       libucx-dev [amd64 arm64 ppc64el riscv64 loong64],
               libpmix-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 alpha ppc64 sparc64],
               libxt-dev,
               procps,
	       python3,
               quilt,
               txt2man,
	       valgrind-if-available,
               x11proto-core-dev
Build-Conflicts: libamdhip64-dev
Build-Depends-Indep: texlive-latex-extra,
                     texlive-latex-recommended,
                     doxygen-latex
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/mpich
Vcs-Git: https://salsa.debian.org/science-team/mpich.git -b debian/latest
Homepage: https://www.mpich.org/

Package: libmpich-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${fortran:Depends},
         g++,
         libmpich12 (= ${binary:Version}),
         libhwloc-dev,
         libucx-dev [${archlist:ucx}],
         ${misc:Depends},
	 mpich (= ${binary:Version})
Description: Development files for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-4.1 standard from the Argonne National Laboratory.
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 4.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH headers and static libraries, as well
 as the compiler wrappers needed to build MPICH programs.

Package: libmpich12
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Shared libraries for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-4.1 standard from the Argonne National Laboratory.
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 4.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH shared libraries.

Package: mpich
Architecture: any
Multi-Arch: foreign
Depends: hwloc-nox | hwloc,
         libmpich12 (= ${binary:Version}),
         ${misc:Depends},
  	 ${perl:Depends},
         ${shlibs:Depends}
Recommends: libmpich-dev (= ${binary:Version})
Suggests: mpich-doc (= ${source:Version})
Description: Implementation of the MPI Message Passing Interface standard
 MPICH is a high-performance and widely portable implementation of the
 MPI-4.1 standard from the Argonne National Laboratory.
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 4.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the program binaries necessary to run MPICH programs.

Package: mpich-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Conflicts: lam-mpidoc,
           lam4-dev,
           mpi-doc,
           openmpi-doc,
           openmpi-mpidoc
Description: Documentation for MPICH
 MPICH is a high-performance and widely portable implementation of the
 MPI-4.1 standard from the Argonne National Laboratory.
 It efficiently supports different computation and communication platforms
 including commodity clusters, SMPs, massively parallel systems, and
 high-speed networks.
 This release has all MPI 4.1 functions and features required by the standard
 with the exception of support for the "external32" portable I/O format and
 user-defined data representations for I/O.
 .
 This package includes the MPICH documentation.

=== debian/rules ===
#! /usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

# Drop flags on old gfortran < 10
GF_FLAGS:= $(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-9),, -fallow-invalid-boz -fallow-argument-mismatch)

export MPICHLIB_CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export MPICHLIB_CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export MPICHLIB_CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export MPICHLIB_FFLAGS:=$(shell dpkg-buildflags --get FFLAGS) $(GF_FLAGS)
export MPICHLIB_FCFLAGS:=$(shell dpkg-buildflags --get FFLAGS) -cpp $(GF_FLAGS)
export FFLAGS:=$(shell dpkg-buildflags --get FFLAGS | sed -e 's/-g //') $(GF_FLAGS)
export F77=f77
export TZ=UTC+0
export V=1

FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
export FC


# Keep old library naming scheme
export MPILIBNAME=mpich

NO_ROMIO_ARCH:= hurd-amd64 hurd-i386
NO_VERBS_ARCH:= hurd-amd64 hurd-i386
NO_SLURM_ARCH:= hurd-amd64 hurd-i386
NO_FABRIC_ARCH:= hurd-amd64 hurd-i386 powerpc sh4
NO_REAL128_ARCH:= armel armhf mipsel hppa m68k sh4
# Pick one as default, unlisted ones get CH3
CH4_UCX_ARCH:= $(shell sed -n -r '/^Build/,/^$$/s/.*libucx-dev *\[([^]]*)\].*/\1/p' debian/control)
CH4_OFI_ARCH:= mips64el alpha ppc64 sparc64

ifeq (,$(filter $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
	VERBS := --with-ibverbs
endif
ifeq (,$(filter $(DEB_HOST_ARCH),$(NO_FABRIC_ARCH)))
	FABRIC := --with-libfabric=/usr
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(NO_REAL128_ARCH)))
	MPICHLIB_FCFLAGS:=$(MPICHLIB_FCFLAGS) -DNO_REAL128
endif
ifeq (,$(filter $(DEB_HOST_ARCH),$(NO_SLURM_ARCH)))
	SLURM := --with-slurm=/usr
endif

UCX:=
ifneq (,$(filter $(DEB_HOST_ARCH),$(CH4_UCX_ARCH)))
	DEVICE:= --with-device=ch4:ucx
	UCX:= --with-ucx=/usr
else ifneq (,$(filter $(DEB_HOST_ARCH),$(CH4_OFI_ARCH)))
	DEVICE:= --with-device=ch4:ofi
else
	DEVICE:= --with-device=ch3
endif

extra_flags += \
	$(VERBS) \
	$(FABRIC) \
	$(SLURM) \
	$(UCX) \
	$(DEVICE) \
	--with-pm=hydra \
	--with-hwloc-prefix=/usr \
	--with-wrapper-dl-type=none \
	--enable-shared \
	--without-yaksa \
	--prefix=/usr \
	--enable-fortran=all \
	--disable-rpath \
	--disable-wrapper-rpath \
	--sysconfdir=/etc/mpich \
	--libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/mpich/lib \
	--includedir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/mpich/include \
	--docdir=/usr/share/doc/mpich


AUTOGENERATED	:= $(patsubst %.in,%,$(wildcard debian/*.in))

%: %.in
	sed 's%@DEB_HOST_MULTIARCH@%$(DEB_HOST_MULTIARCH)%g' < $< > $@

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf ./autogen.sh

override_dh_auto_configure: $(AUTOGENERATED)
	dh_auto_configure -- $(extra_flags) CPPFLAGS="" CFLAGS="" CXXFLAGS="" FFLAGS="$(FFLAGS)" FCFLAGS="$(FFLAGS)" BASH_SHELL=/bin/bash
	dh_auto_configure --sourcedirectory src/pm/hydra -- --with-hwloc-prefix=/usr $(DEVICE) FFLAGS="$(FFLAGS)"
	sed -r -i 's/ +-ffile-prefix-map=[^ ]+//g' src/env/mpifort.bash src/include/mpichinfo.h src/packaging/pkgconfig/mpich.pc src/pm/hydra/hydra_config.h

execute_after_dh_auto_build-indep:
	$(MAKE) -f doc/Makefile.mk

override_dh_auto_install-arch:
	dh_auto_install -a
	dh_auto_install -a --sourcedirectory src/pm/hydra

	# Rename executables (ignore upstream symlinks)
	for i in mpicc mpicxx mpifort; do \
	  (cd debian/tmp/usr/bin/ && mv $$i $$i.mpich); \
	done
    # Rename manpages
    # TODO: manpages not shipped in beta ?
	#for i in mpicc mpicxx mpiexec mpif77 mpifort; do \
	#  (cd debian/tmp/usr/share/man/man1/ && mv $$i.1 $$i.mpich.1);\
	#done

	# Fix incorrect paths in /usr/bin/mpi{cc,cxx,fort}.mpich
	for fn in debian/tmp/usr/bin/mpicc.mpich debian/tmp/usr/bin/mpicxx.mpich \
		debian/tmp/usr/bin/mpifort.mpich; do \
		sed -i 's:$(CURDIR)/debian/tmp/::g' $$fn ;\
	done

execute_before_dh_auto_clean:
	dh_auto_clean --sourcedirectory doc/installguide
	dh_auto_clean --sourcedirectory doc/userguide

execute_after_dh_auto_clean:
	$(RM) $(AUTOGENERATED)

override_dh_installchangelogs:
	dh_installchangelogs README

# Some tests are failing on hurd-amd64 hurd-i386.
# Disable them, to be investiated later
# disable_test_archs = hurd-amd64 hurd-i386
disable_test_archs =
# ifneq (,$(filter $(DEB_HOST_ARCH),$(disable_test_archs)))
override_dh_auto_test:
	@echo "Don't fail on tests in experimental"
	- dh_auto_test || true
# endif

override_dh_gencontrol:
	dh_gencontrol -- -V'archlist:ucx=$(CH4_UCX_ARCH)'

## mpich 4.3.1

=== modules/ucx/docs/Makefile ===
#
# Copyright (c) NVIDIA CORPORATION & AFFILIATES, 2019. ALL RIGHTS RESERVED.
#
# See file LICENSE for terms.
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = source
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== src/mpi/romio/doc/Makefile ===
##
## Copyright (C) by Argonne National Laboratory
##     See COPYRIGHT in top-level directory
##

all:
	latex users-guide.tex
	bibtex users-guide
	latex users-guide.tex
	latex users-guide.tex
	dvipdfm users-guide
	dvips users-guide

clean:
	-rm -f users-guide.toc users-guide.log users-guide.dvi \
	       users-guide.aux users-guide.bbl users-guide.ps \
               users-guide.blg

=== src/pm/hydra/modules/hwloc/contrib/windows-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(hwloc
    LANGUAGES C
    VERSION 2.9.0)

enable_testing()

option(HWLOC_ENABLE_TESTING "Enable testing" ON)
option(HWLOC_SKIP_LSTOPO "don't build/install lstopo")
option(HWLOC_SKIP_TOOLS "don't build/install other hwloc tools")
option(HWLOC_SKIP_INCLUDES "don't install headers")
option(HWLOC_WITH_LIBXML2 "use libxml2 instead of minimal XML")
option(HWLOC_WITH_OPENCL "enable OpenCL support")
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.17)
    option(HWLOC_WITH_CUDA "enable CUDA support")
endif()
option(HWLOC_BUILD_SHARED_LIBS "build shared libraries" ${BUILD_SHARED_LIBS})

set(TOPDIR ${PROJECT_SOURCE_DIR}/../..)

# "libhwloc.*" naming for MSVC and non-MSVC

configure_file(${TOPDIR}/contrib/windows/hwloc_config.h include/hwloc/autogen/config.h COPYONLY)

# Configure dynamically based on platform capabilities
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckCSourceCompiles)

check_include_file("dirent.h" HAVE_DIRENT_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("malloc.h" HAVE_MALLOC_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_symbol_exists(mkstemp "stdlib.h" HAVE_MKSTEMP)
check_symbol_exists(memalign "malloc.h" HAVE_MEMALIGN)

check_symbol_exists(strncasecmp "strings.h" HAVE_STRNCASECMP)
if(MSVC AND HAVE_STRNCASECMP)
    set(hwloc_strncasecmp 1)
    set(hwloc_strncasecmp_fcn strncasecmp)
else()
    set(hwloc_strncasecmp 0)
    set(hwloc_strncasecmp_fcn strncmp)
endif()


set(SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
# disable x86 entirely by default
set(HWLOC_X86_32_ARCH)
set(HWLOC_X86_64_ARCH)
set(HWLOC_HAVE_X86_CPUID 1)
if (CMAKE_SYSTEM_PROCESSOR MATCHES "(^AMD64$|^x86_64$)")
    # "AMD64" on Windows, "x86_64" on Linux
    set(HWLOC_X86_64_ARCH 1)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "(^x86$|i.86)")
    # "x86" on Windows, "i.86" on Linux
    set(HWLOC_X86_32_ARCH 1)
else()
    set(HWLOC_HAVE_X86_CPUID 0)
endif()

check_c_source_compiles("int main(void) {int cpuinfo[4]; __cpuidex(cpuinfo,0,0); return 0;}"
HWLOC_HAVE_MSVC_CPUIDEX
)

# the following lines are disabled until we are sure they are safe with old build environmentx
# - snprintf() returned broken values in the past, hwloc detects it during configure (see 7a4ee26510c06b55fc04aaccbfa18d0ca3b87198)
#   set(HAVE_DECL_SNPRINTF 1)
# - strtoull() had some issues in the past (see 9559bd08b79ef63dce45df87fb7f875b73ecb512)
#   set(HAVE_DECL_STRTOULL 1)

# --- optional external libraries
set(HWLOC_HAVE_LIBXML2)
if(HWLOC_WITH_LIBXML2)
    find_package(LibXml2 REQUIRED)
    set(HWLOC_HAVE_LIBXML2 1)
endif()

set(HWLOC_HAVE_OPENCL)
if(HWLOC_WITH_OPENCL)
    find_package(OpenCL REQUIRED)
    set(HWLOC_HAVE_OPENCL 1)
endif()

set(HAVE_CUDA)
set(HAVE_CUDA_H)
set(HAVE_CUDA_RUNTIME_API_H)
set(HWLOC_HAVE_CUDART)
if(HWLOC_WITH_CUDA)
    find_package(CUDAToolkit REQUIRED)
    set(HAVE_CUDA 1)
    set(HAVE_CUDA_H 1)
    set(HAVE_CUDA_RUNTIME_API_H 1)
    set(HWLOC_HAVE_CUDART 1)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/private_config.h.in include/private/autogen/config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/static-components.h.in include/static-components.h)

# Library

add_compile_definitions($<$<CONFIG:DEBUG>:HWLOC_DEBUG=1>)

# FIXME dll soname
add_library(hwloc
    ${TOPDIR}/hwloc/topology.c
    ${TOPDIR}/hwloc/traversal.c
    ${TOPDIR}/hwloc/distances.c
    ${TOPDIR}/hwloc/memattrs.c
    ${TOPDIR}/hwloc/cpukinds.c
    ${TOPDIR}/hwloc/components.c
    ${TOPDIR}/hwloc/bind.c
    ${TOPDIR}/hwloc/bitmap.c
    ${TOPDIR}/hwloc/pci-common.c
    ${TOPDIR}/hwloc/diff.c
    ${TOPDIR}/hwloc/shmem.c
    ${TOPDIR}/hwloc/misc.c
    ${TOPDIR}/hwloc/base64.c
    ${TOPDIR}/hwloc/topology-noos.c
    ${TOPDIR}/hwloc/topology-synthetic.c
    ${TOPDIR}/hwloc/topology-xml.c
    ${TOPDIR}/hwloc/topology-xml-nolibxml.c
    ${TOPDIR}/hwloc/topology-windows.c
    ${TOPDIR}/hwloc/topology-x86.c
    $<$<BOOL:${HWLOC_HAVE_LIBXML2}>:${TOPDIR}/hwloc/topology-xml-libxml.c>
    $<$<BOOL:${HWLOC_HAVE_OPENCL}>:${TOPDIR}/hwloc/topology-opencl.c>
    $<$<BOOL:${HAVE_CUDA}>:${TOPDIR}/hwloc/topology-cuda.c>
)

target_link_libraries(hwloc PRIVATE
    $<$<BOOL:${HWLOC_HAVE_LIBXML2}>:LibXml2::LibXml2>
    $<$<BOOL:${HWLOC_HAVE_OPENCL}>:OpenCL::OpenCL>
    "$<$<BOOL:${HAVE_CUDA}>:CUDA::cudart;CUDA::cuda_driver>"
)

if(HWLOC_BUILD_SHARED_LIBS)
    target_compile_definitions(hwloc PRIVATE $<$<BOOL:${MSVC}>:_USRDLL>)
endif()

target_include_directories(hwloc PUBLIC
    "$<BUILD_INTERFACE:${TOPDIR}/include;${CMAKE_CURRENT_BINARY_DIR}/include>"
    $<INSTALL_INTERFACE:include>
)

# Tools under utils/hwloc

if(NOT HWLOC_SKIP_TOOLS)

    set(TOOLS
        hwloc-bind
        hwloc-calc
        hwloc-diff
        hwloc-distrib
        hwloc-gather-cpuid
        hwloc-info
        hwloc-patch
    )

    foreach(tool IN ITEMS ${TOOLS})
        add_executable(${tool}
            ${TOPDIR}/utils/hwloc/${tool}.c)
        target_link_libraries(${tool} PRIVATE hwloc)
    endforeach(tool)

endif()

# lstopo

if(NOT HWLOC_SKIP_LSTOPO)

    set(LSTOPOS
        lstopo-no-graphics
        lstopo
        lstopo-win
    )

    set(LSTOPO_COMMON_SOURCES
        ${TOPDIR}/utils/lstopo/lstopo.c
        ${TOPDIR}/utils/lstopo/lstopo-draw.c
        ${TOPDIR}/utils/lstopo/lstopo-tikz.c
        ${TOPDIR}/utils/lstopo/lstopo-fig.c
        ${TOPDIR}/utils/lstopo/lstopo-svg.c
        ${TOPDIR}/utils/lstopo/lstopo-ascii.c
        ${TOPDIR}/utils/lstopo/lstopo-text.c
        ${TOPDIR}/utils/lstopo/lstopo-xml.c
        ${TOPDIR}/utils/hwloc/common-ps.c
    )

    add_executable(lstopo-no-graphics
        ${LSTOPO_COMMON_SOURCES}
    )
    target_link_libraries(lstopo-no-graphics PRIVATE hwloc)

    add_executable(lstopo
        ${LSTOPO_COMMON_SOURCES}
        ${TOPDIR}/utils/lstopo/lstopo-windows.c
    )
    target_compile_definitions(lstopo PRIVATE LSTOPO_HAVE_GRAPHICS)

    add_executable(lstopo-win WIN32
        ${LSTOPO_COMMON_SOURCES}
        ${TOPDIR}/utils/lstopo/lstopo-windows.c
    )
    target_compile_definitions(lstopo-win PRIVATE LSTOPO_HAVE_GRAPHICS)
    target_link_options(lstopo-win PRIVATE "$<$<BOOL:${MSVC}>:/subsystem:windows;/entry:mainCRTStartup>")

    foreach(tool IN ITEMS ${LSTOPOS})
        target_include_directories(${tool} PRIVATE ${TOPDIR}/utils/hwloc)
        target_link_libraries(${tool} PRIVATE hwloc)
    endforeach(tool)

endif()

# Misc

foreach(target IN ITEMS hwloc ${TOOLS} ${LSTOPOS})
    target_compile_definitions(${target} PRIVATE $<$<BOOL:${MSVC}>:_CRT_SECURE_NO_WARNINGS>)
endforeach(target)

# Install

install(TARGETS hwloc)

if(NOT HWLOC_SKIP_TOOLS)
    install(TARGETS ${TOOLS})
endif()

if(NOT HWLOC_SKIP_LSTOPO)
    install(TARGETS ${LSTOPOS})
endif()

if(NOT HWLOC_SKIP_INCLUDES)
    install(FILES ${TOPDIR}/include/hwloc.h TYPE INCLUDE)
    install(DIRECTORY ${TOPDIR}/include/hwloc TYPE INCLUDE FILES_MATCHING PATTERN "*.h")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/hwloc/autogen/config.h DESTINATION include/hwloc/autogen)
endif()

if(MSVC AND BUILD_SHARED_LIBS)
  install(FILES $<TARGET_PDB_FILE:hwloc>
    TYPE BIN
    OPTIONAL)
endif()

# Testing

if(HWLOC_ENABLE_TESTING)
    add_subdirectory(${TOPDIR}/tests/hwloc ${CMAKE_CURRENT_BINARY_DIR}/tests/hwloc)
endif()

=== debian/changelog ===
mpich (4.3.1-3) unstable; urgency=medium

  * Disable pmix - breaks with pmix 6.0.0, ditto hip
  * Close old bug: Closes: #1042412

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Aug 2025 10:29:18 +0100

mpich (4.3.1-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Aug 2025 16:27:27 +0100

mpich (4.3.1-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2
  * Include /etc/mpich/mpixxx_opts.conf in -dev
  * Drop obsolete lintian override
  * SOVERSION now 12.5.1 in links

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 Jul 2025 13:45:19 +0100

mpich (4.3.0-2) experimental; urgency=medium

  * Mark HIP symbols as optional in libmpich12.symbols
  * Add Pmix support on 64-bit systems

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 19 Feb 2025 10:08:24 +0000

mpich (4.3.0-1) experimental; urgency=medium

  * New upstream release
  * Enable hip

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Feb 2025 10:14:50 +0000

mpich (4.3.0~rc4-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 25 Jan 2025 16:13:39 +0000

mpich (4.3.0~rc3-1) experimental; urgency=medium

  * New upstream release
  * d/rules: run autoconf in src/mpl needed to cope with new
    --runstatedir parameter

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Jan 2025 11:11:16 +0000

mpich (4.3.0~rc2-1) experimental; urgency=medium

  * New upstream release
  * library version numbers now 12.4.2
  * Add patch that was accidentally dropped:
     Add Deps to libmpich-dev needed for pkg-config. Closes: #1028172
  * Drop ppc64el ucx dependency; add riscv64. UCX doesn't have ppc64el support
    which makes it a blocker
  * Don't call dh_dwz: dwz crashes
  * Now B-D on libamdhip64-dev and hipcc

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Jan 2025 12:55:17 +0000

mpich (4.3.0~rc1-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Dec 2024 07:02:31 +0000

mpich (4.3.0~b1-1) experimental; urgency=medium

  * New upstream release
    - Set soversion links to 0.0.0 for non-release version of lib
  * Now add B-D on libamdhip64-dev, hipcc
  * Override dh_dwz as it breaks
  * Patch for hipamd64:
      * undefined-type-gpu.patch
  * Add patch that was accidentally dropped:
     Add Deps to libmpich-dev needed for pkg-config. Closes: #1028172
  * Drop ppc64el ucx dependency; add riscv64. UCX doesn't have ppc64el support
    which makes it a blocker

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 23 Dec 2024 08:53:13 +0000

mpich (4.2.2-1) experimental; urgency=medium

  * New upstream release
  * library versions now 12.4.2

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Jul 2024 13:55:21 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,6 @@
 	       libfabric-dev [!hurd-any !powerpc !sh4],
 	       libnuma-dev [!hurd-any],
 	       libucx-dev [amd64 arm64 ppc64el riscv64 loong64],
-               libpmix-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 alpha ppc64 sparc64],
                libxt-dev,
                procps,
 	       python3,
@@ -24,12 +23,11 @@
                txt2man,
 	       valgrind-if-available,
                x11proto-core-dev
-Build-Conflicts: libamdhip64-dev
 Build-Depends-Indep: texlive-latex-extra,
                      texlive-latex-recommended,
                      doxygen-latex
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/mpich
 Vcs-Git: https://salsa.debian.org/science-team/mpich.git -b debian/latest
 Homepage: https://www.mpich.org/

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#! /usr/bin/make -f
+#!/usr/bin/make -f
 
 export DH_VERBOSE=1
 
@@ -22,6 +22,8 @@
 FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
 export FC
 
+export HIPCXX=clang++-19
+
 
 # Keep old library naming scheme
 export MPILIBNAME=mpich
@@ -34,6 +36,8 @@
 # Pick one as default, unlisted ones get CH3
 CH4_UCX_ARCH:= $(shell sed -n -r '/^Build/,/^$$/s/.*libucx-dev *\[([^]]*)\].*/\1/p' debian/control)
 CH4_OFI_ARCH:= mips64el alpha ppc64 sparc64
+HIP_ARCH:= $(shell sed -n -r '/^Build/,/^$$/s/.*libamdhip64-dev *\[([^]]*)\].*/\1/p' debian/control)
+PMIX_ARCH:= $(shell sed -n -r '/^Build/,/^$$/s/.*libpmix-dev *\[([^]]*)\].*/\1/p' debian/control)
 
 ifeq (,$(filter $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
 	VERBS := --with-ibverbs
@@ -47,6 +51,12 @@
 ifeq (,$(filter $(DEB_HOST_ARCH),$(NO_SLURM_ARCH)))
 	SLURM := --with-slurm=/usr
 endif
+
+#HIP:= $(if $(filter $(DEB_TARGET_ARCH), $(HIP_ARCH)),--with-hip=/usr,)
+#PMIX:= $(if $(filter $(DEB_TARGET_ARCH), $(PMIX_ARCH)),--with-pmix=/usr/lib/${DEB_HOST_MULTIARCH}/pmix2,)
+# Disable pmix this build
+PMIX:= 
+HIP:= 
 
 UCX:=
 ifneq (,$(filter $(DEB_HOST_ARCH),$(CH4_UCX_ARCH)))
@@ -63,6 +73,8 @@
 	$(FABRIC) \
 	$(SLURM) \
 	$(UCX) \
+	$(HIP) \
+	$(PMIX) \
 	$(DEVICE) \
 	--with-pm=hydra \
 	--with-hwloc-prefix=/usr \
@@ -88,6 +100,8 @@
 	dh $@
 
 override_dh_autoreconf:
+	# need to regenerate configure to cope with --runstatedir
+	(cd src/mpl && autoconf)
 	dh_autoreconf ./autogen.sh
 
 override_dh_auto_configure: $(AUTOGENERATED)
@@ -140,3 +154,6 @@
 
 override_dh_gencontrol:
 	dh_gencontrol -- -V'archlist:ucx=$(CH4_UCX_ARCH)'
+
+override_dh_dwz:
+	@echo "Skip dwx: crashes"
